#include <stdbool.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>

#include "config.h"

typedef struct {
	unsigned int id;
	pthread_t thread;
	pthread_barrier_t *barrier;
} thread_t;

void *worker (void *arg) {
	thread_t *info = arg;

	for (size_t i = 0; i < BARRIERRUNS; i++) {
		unsigned int foo = 0;
		for (size_t j = 0; j < ADDRUNS; j++) {
			foo += j;
		}
		//printf ("worker %u done, %u\n", info->id, foo);
		pthread_barrier_wait (info->barrier);
	}
	return NULL;
}

int main () {
	pthread_barrier_t b;
	thread_t w[THREAD_NUM];

	pthread_barrier_init (&b, NULL, THREAD_NUM);

	for (size_t i = 0; i < sizeof (w)/sizeof (*w); i++) {
		w[i].id = i;

		/* init barrier */
		w[i].barrier = &b;
	}

	for (size_t i = 0; i < sizeof (w)/sizeof (*w); i++) {
		pthread_create (&w[i].thread, NULL, worker, &w[i]);
	}

	for (size_t i = 0; i < sizeof (w)/sizeof (*w); i++) {
		pthread_join (w[i].thread, NULL);
	}
}

